"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createWithToken = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const generated_1 = require("./generated");
const create_1 = require("./create");
const createWithToken = async (context, input) => {
    const capacity = 'availableTickets' in input.settings ? input.settings.availableTickets : 1;
    const space = (0, create_1.raffleDataLength)(capacity);
    return (0, umi_1.transactionBuilder)()
        .add((0, mpl_toolbox_1.createAccount)(context, {
        newAccount: input.raffle,
        lamports: await context.rpc.getRent(space),
        space,
        programId: context.programs.getPublicKey('mplWaffle', 'WAFFcc6NZowztN8mFeEdct8sSNr8CVAf9gqmBMcr8S2'),
    }))
        .add((0, generated_1.initializeWithToken)(context, {
        ...input,
        raffle: input.raffle.publicKey,
    }));
};
exports.createWithToken = createWithToken;
//# sourceMappingURL=createWithToken.js.map