"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRaffleSize = exports.getRaffleGpaBuilder = exports.safeFetchAllRaffle = exports.fetchAllRaffle = exports.safeFetchRaffle = exports.fetchRaffle = exports.deserializeRaffle = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const hooked_1 = require("../../hooked");
const types_1 = require("../types");
function deserializeRaffle(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, (0, hooked_1.getRaffleAccountDataSerializer)());
}
exports.deserializeRaffle = deserializeRaffle;
async function fetchRaffle(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Raffle');
    return deserializeRaffle(maybeAccount);
}
exports.fetchRaffle = fetchRaffle;
async function safeFetchRaffle(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeRaffle(maybeAccount) : null;
}
exports.safeFetchRaffle = safeFetchRaffle;
async function fetchAllRaffle(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Raffle');
        return deserializeRaffle(maybeAccount);
    });
}
exports.fetchAllRaffle = fetchAllRaffle;
async function safeFetchAllRaffle(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeRaffle(maybeAccount));
}
exports.safeFetchAllRaffle = safeFetchAllRaffle;
function getRaffleGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplWaffle', 'WAFFcc6NZowztN8mFeEdct8sSNr8CVAf9gqmBMcr8S2');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        refundFee: [1, (0, serializers_1.u16)()],
        state: [3, (0, types_1.getStateSerializer)()],
        padding: [4, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 4 })],
        authority: [8, (0, serializers_1.publicKey)()],
        registrar: [40, (0, serializers_1.publicKey)()],
        treasury: [72, (0, serializers_1.publicKey)()],
        mint: [104, (0, serializers_1.publicKey)()],
        startDate: [136, (0, umi_1.mapDateTimeSerializer)((0, serializers_1.i64)())],
        endDate: [144, (0, umi_1.mapDateTimeSerializer)((0, serializers_1.i64)())],
        ticketValue: [152, (0, serializers_1.u64)()],
        availableTickets: [160, (0, serializers_1.u64)()],
        issued: [168, (0, serializers_1.u64)()],
        selected: [176, (0, serializers_1.u64)()],
        timestamp: [184, (0, serializers_1.i64)()],
        allocator: [192, (0, types_1.getAllocatorSerializer)()],
    })
        .deserializeUsing((account) => deserializeRaffle(account))
        .whereField('key', types_1.Key.Raffle);
}
exports.getRaffleGpaBuilder = getRaffleGpaBuilder;
function getRaffleSize() {
    return 192;
}
exports.getRaffleSize = getRaffleSize;
//# sourceMappingURL=raffle.js.map