"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchTicketFromSeeds = exports.fetchTicketFromSeeds = exports.findTicketPda = exports.getTicketSize = exports.getTicketGpaBuilder = exports.safeFetchAllTicket = exports.fetchAllTicket = exports.safeFetchTicket = exports.fetchTicket = exports.deserializeTicket = exports.getTicketAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getTicketAccountDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['key', (0, types_1.getKeySerializer)()],
        ['bump', (0, serializers_1.u8)()],
        ['settled', (0, serializers_1.bool)()],
        ['padding', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 5 })],
        ['raffle', (0, serializers_1.publicKey)()],
        ['owner', (0, serializers_1.publicKey)()],
        ['stub', (0, serializers_1.publicKey)()],
        ['sequence', (0, serializers_1.u64)()],
    ], { description: 'TicketAccountData' }), (value) => ({ ...value, key: types_1.Key.Ticket }));
}
exports.getTicketAccountDataSerializer = getTicketAccountDataSerializer;
function deserializeTicket(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getTicketAccountDataSerializer());
}
exports.deserializeTicket = deserializeTicket;
async function fetchTicket(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Ticket');
    return deserializeTicket(maybeAccount);
}
exports.fetchTicket = fetchTicket;
async function safeFetchTicket(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeTicket(maybeAccount) : null;
}
exports.safeFetchTicket = safeFetchTicket;
async function fetchAllTicket(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Ticket');
        return deserializeTicket(maybeAccount);
    });
}
exports.fetchAllTicket = fetchAllTicket;
async function safeFetchAllTicket(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeTicket(maybeAccount));
}
exports.safeFetchAllTicket = safeFetchAllTicket;
function getTicketGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplWaffle', 'WAFFcc6NZowztN8mFeEdct8sSNr8CVAf9gqmBMcr8S2');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        bump: [1, (0, serializers_1.u8)()],
        settled: [2, (0, serializers_1.bool)()],
        padding: [3, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 5 })],
        raffle: [8, (0, serializers_1.publicKey)()],
        owner: [40, (0, serializers_1.publicKey)()],
        stub: [72, (0, serializers_1.publicKey)()],
        sequence: [104, (0, serializers_1.u64)()],
    })
        .deserializeUsing((account) => deserializeTicket(account))
        .whereField('key', types_1.Key.Ticket);
}
exports.getTicketGpaBuilder = getTicketGpaBuilder;
function getTicketSize() {
    return 112;
}
exports.getTicketSize = getTicketSize;
function findTicketPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplWaffle', 'WAFFcc6NZowztN8mFeEdct8sSNr8CVAf9gqmBMcr8S2');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('ticket'),
        (0, serializers_1.publicKey)().serialize(seeds.stub),
    ]);
}
exports.findTicketPda = findTicketPda;
async function fetchTicketFromSeeds(context, seeds, options) {
    return fetchTicket(context, findTicketPda(context, seeds), options);
}
exports.fetchTicketFromSeeds = fetchTicketFromSeeds;
async function safeFetchTicketFromSeeds(context, seeds, options) {
    return safeFetchTicket(context, findTicketPda(context, seeds), options);
}
exports.safeFetchTicketFromSeeds = safeFetchTicketFromSeeds;
//# sourceMappingURL=ticket.js.map