"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchTicketRecordFromSeeds = exports.fetchTicketRecordFromSeeds = exports.findTicketRecordPda = exports.getTicketRecordSize = exports.getTicketRecordGpaBuilder = exports.safeFetchAllTicketRecord = exports.fetchAllTicketRecord = exports.safeFetchTicketRecord = exports.fetchTicketRecord = exports.deserializeTicketRecord = exports.getTicketRecordAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
function getTicketRecordAccountDataSerializer() {
    return (0, serializers_1.struct)([
        ['data', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 8 })],
        ['raffle', (0, serializers_1.publicKey)()],
    ], { description: 'TicketRecordAccountData' });
}
exports.getTicketRecordAccountDataSerializer = getTicketRecordAccountDataSerializer;
function deserializeTicketRecord(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getTicketRecordAccountDataSerializer());
}
exports.deserializeTicketRecord = deserializeTicketRecord;
async function fetchTicketRecord(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'TicketRecord');
    return deserializeTicketRecord(maybeAccount);
}
exports.fetchTicketRecord = fetchTicketRecord;
async function safeFetchTicketRecord(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeTicketRecord(maybeAccount) : null;
}
exports.safeFetchTicketRecord = safeFetchTicketRecord;
async function fetchAllTicketRecord(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'TicketRecord');
        return deserializeTicketRecord(maybeAccount);
    });
}
exports.fetchAllTicketRecord = fetchAllTicketRecord;
async function safeFetchAllTicketRecord(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeTicketRecord(maybeAccount));
}
exports.safeFetchAllTicketRecord = safeFetchAllTicketRecord;
function getTicketRecordGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplWaffle', 'WAFFcc6NZowztN8mFeEdct8sSNr8CVAf9gqmBMcr8S2');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        data: [0, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 8 })],
        raffle: [8, (0, serializers_1.publicKey)()],
    })
        .deserializeUsing((account) => deserializeTicketRecord(account));
}
exports.getTicketRecordGpaBuilder = getTicketRecordGpaBuilder;
function getTicketRecordSize() {
    return 40;
}
exports.getTicketRecordSize = getTicketRecordSize;
function findTicketRecordPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplWaffle', 'WAFFcc6NZowztN8mFeEdct8sSNr8CVAf9gqmBMcr8S2');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('ticket_record'),
        (0, serializers_1.publicKey)().serialize(seeds.raffle),
        (0, serializers_1.u64)().serialize(seeds.recordNumber),
    ]);
}
exports.findTicketRecordPda = findTicketRecordPda;
async function fetchTicketRecordFromSeeds(context, seeds, options) {
    return fetchTicketRecord(context, findTicketRecordPda(context, seeds), options);
}
exports.fetchTicketRecordFromSeeds = fetchTicketRecordFromSeeds;
async function safeFetchTicketRecordFromSeeds(context, seeds, options) {
    return safeFetchTicketRecord(context, findTicketRecordPda(context, seeds), options);
}
exports.safeFetchTicketRecordFromSeeds = safeFetchTicketRecordFromSeeds;
//# sourceMappingURL=ticketRecord.js.map