"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeWithToken = exports.getInitializeWithTokenInstructionDataSerializer = void 0;
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getInitializeWithTokenInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.u8)()],
        ['settings', (0, types_1.getSettingsSerializer)()],
    ], { description: 'InitializeWithTokenInstructionData' }), (value) => ({ ...value, discriminator: 1 }));
}
exports.getInitializeWithTokenInstructionDataSerializer = getInitializeWithTokenInstructionDataSerializer;
// Instruction.
function initializeWithToken(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplWaffle', 'WAFFcc6NZowztN8mFeEdct8sSNr8CVAf9gqmBMcr8S2');
    // Accounts.
    const resolvedAccounts = {
        raffle: { index: 0, isWritable: true, value: input.raffle ?? null },
        authority: { index: 1, isWritable: false, value: input.authority ?? null },
        registrar: { index: 2, isWritable: false, value: input.registrar ?? null },
        treasury: { index: 3, isWritable: true, value: input.treasury ?? null },
        mint: { index: 4, isWritable: false, value: input.mint ?? null },
        payer: { index: 5, isWritable: true, value: input.payer ?? null },
        systemProgram: {
            index: 6,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
        splTokenProgram: {
            index: 7,
            isWritable: false,
            value: input.splTokenProgram ?? null,
        },
        splAtaProgram: {
            index: 8,
            isWritable: false,
            value: input.splAtaProgram ?? null,
        },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.authority.value) {
        resolvedAccounts.authority.value = context.identity;
    }
    if (!resolvedAccounts.treasury.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.treasury.value = (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
                owner: (0, shared_1.expectPublicKey)(resolvedAccounts.authority.value),
                mint: (0, shared_1.expectPublicKey)(resolvedAccounts.mint.value),
            });
        }
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.systemProgram.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.systemProgram.value = context.programs.getPublicKey('systemProgram', '11111111111111111111111111111111');
            resolvedAccounts.systemProgram.isWritable = false;
        }
    }
    if (!resolvedAccounts.splTokenProgram.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.splTokenProgram.value = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
            resolvedAccounts.splTokenProgram.isWritable = false;
        }
    }
    if (!resolvedAccounts.splAtaProgram.value) {
        if (resolvedAccounts.mint.value) {
            resolvedAccounts.splAtaProgram.value = context.programs.getPublicKey('splAssociatedToken', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL');
            resolvedAccounts.splAtaProgram.isWritable = false;
        }
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getInitializeWithTokenInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.initializeWithToken = initializeWithToken;
//# sourceMappingURL=initializeWithToken.js.map