import { Serializer } from '@metaplex-foundation/umi/serializers';
import { PublicKey } from '@metaplex-foundation/umi';
import { Node } from '../generated';
import { RaffleAccountData as BaseRaffleAccountData, RaffleAccountDataArgs as BaseRaffleAccountDataArgs } from '../generated/types/raffleAccountData';
export type RaffleV2AccountData = Omit<BaseRaffleAccountData, 'padding'> & {
    winners: Node[];
    ticketRecords: Array<PublicKey>;
};
export type RaffleV2AccountDataArgs = Omit<BaseRaffleAccountDataArgs, 'padding'> & {
    winners: Node[];
    ticketRecords: Array<PublicKey>;
};
export declare const getRaffleV2AccountDataSerializer: () => Serializer<RaffleV2AccountDataArgs, RaffleV2AccountData>;
