"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveMintArg = exports.resolveTicketTokenWhenMintArg = exports.resolveOwnerTokenWhenMintArg = void 0;
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const umi_1 = require("@metaplex-foundation/umi");
const generated_1 = require("../generated");
const resolveOwnerTokenWhenMintArg = (context, accounts, args, _programId, isWritable) => ({
    value: (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
        owner: (0, generated_1.expectPublicKey)(accounts.owner?.value),
        mint: (0, umi_1.publicKey)(args.mint),
    }),
    isWritable,
});
exports.resolveOwnerTokenWhenMintArg = resolveOwnerTokenWhenMintArg;
const resolveTicketTokenWhenMintArg = (context, accounts, args, _programId, isWritable) => ({
    value: (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
        owner: (0, generated_1.expectPublicKey)(accounts.ticket?.value),
        mint: (0, umi_1.publicKey)(args.mint),
    }),
    isWritable,
});
exports.resolveTicketTokenWhenMintArg = resolveTicketTokenWhenMintArg;
const resolveMintArg = (context, _accounts, args, _programId, isWritable) => args.mint !== null;
exports.resolveMintArg = resolveMintArg;
//# sourceMappingURL=resolver.js.map